<!DOCTYPE html>
<html>
  <body style="font-family: Arial, sans-serif; padding: 20px">
    <h1 style="text-align: center; margin-bottom: 20px">Weighted Strings</h1>
    <div style="display: flex; justify-content: center">
      <div>
        <div style="margin-bottom: 20px">
          <label
            for="stringInput"
            style="width: 230px; display: inline-block; text-align: right"
            >Input String:</label
          >
          <input
            type="text"
            id="stringInput"
            style="
              margin-left: 10px;
              height: 34px;
              border: 1px solid #d3d3d3;
              padding: 0 10px;
              border-radius: 4px;
            "
          />
        </div>
        <div style="margin-bottom: 20px">
          <label
            for="queryInput"
            style="width: 230px; display: inline-block; text-align: right"
            >Queries (comma-separated):</label
          >
          <input
            type="text"
            id="queryInput"
            style="
              margin-left: 10px;
              height: 34px;
              border: 1px solid #d3d3d3;
              padding: 0 10px;
              border-radius: 4px;
            "
          />
        </div>
        <div style="margin-bottom: 20px">
          <label
            for="queryInput"
            style="width: 230px; display: inline-block; text-align: right"
          >
          </label>
          <button onclick="runWeightedStrings()" style="padding: 10px">
            Result
          </button>
        </div>

        <div
          id="result"
          style="
            margin-top: 20px;
            width: 500px;
            background-color: #efefef;
            border: 1px solid #d3d3d3;
            border-radius: 4px;
            text-align: center;
            height: 50px;
            line-height: 50px;
          "
        ></div>
      </div>
    </div>

    <script>
      function weightedStrings(s, queries) {
        const weights = new Set();
        let weight = 0;
        let prevChar = "";

        for (let char of s) {
          if (char !== prevChar) {
            weight = 0;
            prevChar = char;
          }
          weight += char.charCodeAt(0) - "a".charCodeAt(0) + 1;
          weights.add(weight);
        }

        return queries.map((query) => (weights.has(query) ? "Yes" : "No"));
      }

      function runWeightedStrings() {
        const inputString = document.getElementById("stringInput").value;
        const inputQueries = document.getElementById("queryInput").value;
        const queries = inputQueries
          .split(",")
          .map((query) => parseInt(query.trim()));
        const result = weightedStrings(inputString, queries);
        document.getElementById("result").innerText = `Result: ${result.join(
          ", "
        )}`;
      }
    </script>
  </body>
</html>
